package org.processmining.logprojection;

import gnu.trove.map.TObjectIntMap;

import java.io.Serializable;
import java.util.Collection;
import java.util.Map;

import org.deckfour.xes.extension.XExtension;
import org.deckfour.xes.model.XAttribute;
import org.deckfour.xes.model.XAttributeMap;
import org.deckfour.xes.model.XLog;

public class XLogDataManager extends DataManager<XLog> {

	private static final long serialVersionUID = 6865142675611928825L;

	private final Map<String, XExtension> key2extension;

	// Stores attributes for an XLog
	public <M extends Map<String, XExtension> & Serializable> XLogDataManager(
			M key2extension, StringHandler stringHandler,
			Collection<XAttribute> attributes, TObjectIntMap<String> lit2index) {
		super(stringHandler, attributes, lit2index, 2 * 1024, 0, false);
		this.key2extension = key2extension;
	}

	@Override
	protected XLog readObjectFromBlock(byte[] block, int ptr,
			boolean forAddingAttributes) {
		XAttributeMap attributes = FACTORY.createAttributeMap();

		Attribute[] globalKeys = getKeys();

		for (int i = 0; i < globalKeys.length; i++) {
			readAttributeIntoScope(globalKeys, ptr, block, i, attributes,
					key2extension, forAddingAttributes);
		}
		return FACTORY.createLog(attributes);

	}

}
