package org.processmining.logprojection.lightxlog;

import org.processmining.logprojection.LogView;

public class LightEvent extends AbstractAttributable {

	private String eventClass;
	private int eventClassNumber;

	public LightEvent(LogView view, int number, String eventClass,
			int eventClassNumber) {
		super(view, view.getEventDataManager(), number);
		this.eventClass = eventClass;
		setNameIndex(eventClassNumber);
	}

	public int getNameIndex() {
		return eventClassNumber;
	}

	public String getName() {
		return eventClass;
	}

	public String toString() {
		return getName();
	}

	/**
	 * Equality is based on the name of the trace
	 */
	public boolean equals(Object o) {
		return (o instanceof LightEvent) && ((LightEvent) o).number == number;
	}

	public int hashCode() {
		return number;
	}

	int getTraceNumber() {
		return view.getEventDataManager().getTraceForEvent(number);
	}

	public void setNameIndex(int label) {
		this.eventClassNumber = label;
	}

}
