package org.processmining.logprojection.plugins.dottedchart.ui;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.Frame;

import org.processmining.contexts.uitopia.UIPluginContext;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.framework.util.ui.widgets.InspectorPanel;
import org.processmining.logprojection.LogView;
import org.processmining.logprojection.plugins.dottedchart.DottedChart.DottedChartException;

public class DottedChartInspector extends InspectorPanel {

	private DottedChartPanel panel;

	public DottedChartInspector(LogView view, PluginContext context) throws DottedChartException {
		this(view, null, context);
	}

	public DottedChartInspector(LogView view, Frame owner) throws DottedChartException {
		this(view, owner, null);
	}

	@Deprecated
	public DottedChartInspector(LogView view) throws DottedChartException {
		this(view, null, null);
	}

	protected DottedChartInspector(LogView view, Frame owner, PluginContext context) throws DottedChartException {
		super(owner != null ? owner : context instanceof UIPluginContext ? ((UIPluginContext) context)
				.getGlobalContext().getUI() : (Frame) null);

		panel = new DottedChartPanel(view);
		if (context != null) {
			panel.addListener(context);
		}

		setLayout(new BorderLayout());
		add(panel);

		// add legend
		addInfo("Legend", new LegendDialog(panel.getDottedChart()));

		getInspector().setMinimumSize(new Dimension(100, 100));
		getInspector().setMaximumSize(new Dimension(200, 200));

	}

	public DottedChartPanel getDottedChartPanel() {
		return panel;
	}

	public LogView getLogView() {
		return panel.getLogView();
	}

}
