package org.processmining.logprojection.sorting;

import org.processmining.logprojection.Attribute;
import org.processmining.logprojection.LogView;

public class LastEventAttributeTraceSorter extends
		AbstractEventBasedTraceSorter {

	public LastEventAttributeTraceSorter(LogView view, Attribute attribute) {
		super(view, attribute);
	}

	@Override
	public int compare(Integer o1, Integer o2) {
		if (view.getTraceLength(o1) == 0) {
			if (view.getTraceLength(o2) == 0) {
				return o1.intValue() - o2.intValue();
			}
			return 1;
		}
		if (view.getTraceLength(o2) == 0) {
			return -1;
		}

		int e1 = view.getFirstEventNumber(o1.intValue())
				+ view.getTraceLength(o1.intValue()) - 1;
		int e2 = view.getFirstEventNumber(o2.intValue())
				+ view.getTraceLength(o2.intValue()) - 1;
		int res = compare(view.getEventDataManager(), e1, e2);
		if (res == 0) {
			return o1 - o2;
		} else {
			return res;
		}

	}

	@Override
	public String getDescription() {
		return "Sort on " + attribute.getKey() + " of last event.";
	}

	public boolean equals(Object o) {
		if (o instanceof LastEventAttributeTraceSorter) {
			return ((LastEventAttributeTraceSorter) o).attribute
					.equals(attribute);
		}
		return false;
	}

}